# -*- coding: cp1252 -*-
#!/usr/bin/env  python
# ===================================
# by Ph. MARON, 15th February 2012
# ===================================

""" 
    This programm is used to extrapolate a 2D Mercator file.
    in order to interpolate all the data on a son grid
       
    Parameters of the script are at line 15, 127 to 128
"""

import sys
sys.path.append("..\Class")
import hdf5files
import h5py
from h5py import *
import numpy
from numpy import array, amin, amax
from pylab import *
from math import sqrt

def str5(i):
    if i<10:
        str5='0000'+str(i)
    elif i<100:
        str5='000'+str(i)
    elif i<1000:
        str5='00'+str(i)    
    elif i<10000:
        str5='0'+str(i)    
    elif i<100000:
        str5=str(i)    
    return str5
 
def extrapole(var, ex_value):
    """ extrapolation de la grille vers les cases contenant des -99 
        attention tous les cas de figures ne sont pas pris en compte
     """
    new_var=var.copy()
    
    for i in range(var.shape[0]):
        maxi =var.shape[0]-1
        for j in range (var.shape[1]):
            maxj=var.shape[1]-1
            if ex_value==0:
                # print  float(var[i,j]), float(ex_value),float(var[i,j])== float(ex_value)
                if float(var[i,j])== float(ex_value):
                    # n=raw_input('Type Enter to continue')
                    sum=0
                    nb=0
                    if  i!=0 and j!=0 and float(var[i-1,j-1])!= float(ex_value) :
                        sum =sum+var[i-1,j-1]/sqrt(2)
                        nb=nb+1./sqrt(2)
                    if i!=0 and float(var[i-1,j])!= float(ex_value) :
                        sum =sum+var[i-1,j]
                        nb=nb+1
                    if i!=0  and j!=maxj and float(var[i-1,j+1])!= float(ex_value) :
                            sum =sum+var[i-1,j+1]/sqrt(2)
                            nb=nb+1./sqrt(2)
                    if j!=0  and float(var[i,j-1])!= float(ex_value):
                        sum =sum+var[i,j-1]
                        nb=nb+1                
                    if j!=maxj and float(var[i,j+1])!= float(ex_value):
                        sum =sum+var[i,j+1]
                        nb=nb+1                
                    if  i!=maxi and j!=0 and float(var[i+1,j-1])!= float(ex_value):
                        sum =sum+var[i+1,j-1]/sqrt(2)
                        nb=nb+1./sqrt(2)          
                    if i!=maxi and float(var[i+1,j])!= float(ex_value):
                        sum =sum+var[i+1,j]
                        nb=nb+1               
                    if   i!=maxi and j!=maxj and float(var[i+1,j+1])!= float(ex_value):
                        sum =sum+var[i+1,j+1]/sqrt(2)
                        nb=nb+1./sqrt(2)                
                    if nb!=0:
                        new_var[i,j]=sum/nb
            else:
                # print var[i,j], ex_value, abs((var[i,j]-ex_value)/ex_value)
                # n=raw_input('Type Enter to continue')  
                if abs((var[i,j]-ex_value)/ex_value)<1e-6:
                    sum=0
                    nb=0
                    if  i!=0 and j!=0 and abs((var[i-1,j-1]-ex_value)/ex_value)>1e-6 :
                        sum =sum+var[i-1,j-1]/sqrt(2)
                        nb=nb+1./sqrt(2)
                    if i!=0 and abs((var[i-1,j]-ex_value)/ex_value)>1e-6 :
                        sum =sum+var[i-1,j]
                        nb=nb+1
                    if i!=0  and j!=maxj and abs((var[i-1,j+1]-ex_value)/ex_value)>1e-6 :
                            sum =sum+var[i-1,j+1]/sqrt(2)
                            nb=nb+1./sqrt(2)
                    if j!=0  and abs((var[i,j-1]-ex_value)/ex_value)>1e-6:
                        sum =sum+var[i,j-1]
                        nb=nb+1                
                    if j!=maxj and abs((var[i,j+1]-ex_value)/ex_value)>1e-6:
                        sum =sum+var[i,j+1]
                        nb=nb+1                
                    if  i!=maxi and j!=0 and abs((var[i+1,j-1]-ex_value)/ex_value)>1e-6:
                        sum =sum+var[i+1,j-1]/sqrt(2)
                        nb=nb+1./sqrt(2)          
                    if i!=maxi and abs((var[i+1,j]-ex_value)/ex_value)>1e-6:
                        sum =sum+var[i+1,j]
                        nb=nb+1               
                    if   i!=maxi and j!=maxj and abs((var[i+1,j+1]-ex_value)/ex_value)>1e-6:
                        sum =sum+var[i+1,j+1]/sqrt(2)
                        nb=nb+1./sqrt(2)                
                    if nb!=0:
                        new_var[i,j]=sum/nb
                        # print i,j, new_var[i,j]
                        # n=raw_input('Type Enter to continue')  
  
    if len(var.shape)==2:
        Extrapole=new_var.copy()
    elif len(var.shape)==3:
        Extrapole=zeros(var.shape)    
        Extrapole[0,:]=new_var.copy
            
    return Extrapole
 # =====================================================
 
 
# ===================================
# PARAMETERS TO FILL
# ===================================
inputfilename ='Mercator_2D_Extrapole_Sample.hdf5'
outputfilename='Mercator_2D_Extrapole_Output.hdf5'
# ===================================

print '============================================================='
print '    Mercator_2DExtrapole.py'
print '============================================================='


# identification du fichier Origine
m_file=hdf5files.Hdf5(inputfilename)
# Ouverture et creation du fichier
h5file = h5py.File(outputfilename, mode = "w")

# ===== Create Grid group ===========================
print '========== create Grid group'
ggrid = h5file.create_group( 'Grid')
ggrid.attrs['Minimum']=float64(amin(array(m_file.connectionx[:])))
ggrid.attrs['Maximum']=float64 (amax(array(m_file.connectionx[:])))

# ==== Create arrays of Grid
# Identical to the input file execpt for 'VerticalZ' fields
# === Bathymetry
print '========== create bathymetry field'
shape=m_file.bathymetry.shape
gdbathymetry=ggrid.create_dataset ('Bathymetry',shape, dtype='f4', maxshape=shape, compression=6,chunks=shape)

gdbathymetry[:]=extrapole(array(m_file.bathymetry[:]),-99)
gdbathymetry.attrs['Minimum']=float64(amin(gdbathymetry))
gdbathymetry.attrs['Maximum']=float64 (amax(gdbathymetry))
gdbathymetry.attrs['Units']= '-'

# === ConnectionX
print '========== create Connection X field'
shape=m_file.connectionx.shape
gdconnectionx=ggrid.create_dataset ('ConnectionX',shape, dtype='f4', maxshape=shape, compression=6,chunks=shape)

gdconnectionx[:]=array(m_file.connectionx[:])
gdconnectionx.attrs['Minimum']=float64(amin(gdconnectionx))
gdconnectionx.attrs['Maximum']=float64 (amax(gdconnectionx))
gdconnectionx.attrs['Units']= 'm'

# === ConnectionY
print '========== create Connection Y field'
shape=m_file.connectiony.shape
gdconnectiony=ggrid.create_dataset ('ConnectionY',shape, dtype='f4', maxshape=shape, compression=6,chunks=shape)

gdconnectiony[:]=array(m_file.connectiony[:])
gdconnectiony.attrs['Minimum']=float64(amin(gdconnectiony))
gdconnectiony.attrs['Maximum']=float64 (amax(gdconnectiony))
gdconnectiony.attrs['Units']= 'm'

# === Latitude
print '========== create Latitude field'
shape=m_file.latitude.shape
gdlatitude=ggrid.create_dataset ('Latitude',shape, dtype='f4', maxshape=shape, compression=6,chunks=shape)

gdlatitude[:]=array(m_file.latitude[:])
gdlatitude.attrs['Minimum']=float32(amin(gdlatitude))
gdlatitude.attrs['Maximum']=float32 (amax(gdlatitude))
gdlatitude.attrs['Units']= ''

# === Longitude
print '========== create Longitude field'
shape=m_file.longitude.shape
gdlongitude=ggrid.create_dataset ('Longitude',shape, dtype='f4', maxshape=shape, compression=6,chunks=shape)

gdlongitude[:]=array(m_file.longitude[:])
gdlongitude.attrs['Minimum']=float64(amin(gdlongitude))
gdlongitude.attrs['Maximum']=float64 (amax(gdlongitude))
gdlongitude.attrs['Units']= '' 

# === WaterPoints3D
print '========== create WaterPoints3D field', array(m_file.waterpoints3d).shape
shape=m_file.waterpoints3d.shape
gdwaterpoints=ggrid.create_dataset ('WaterPoints3D',shape, dtype='i4', maxshape=shape, compression=6,chunks=shape)

gdwaterpoints[0,:,:]=extrapole(array(m_file.waterpoints3d[0,:,:]),0)
gdwaterpoints.attrs['Minimum']=float32(amin(gdwaterpoints))
gdwaterpoints.attrs['Maximum']=float32 (amax(gdwaterpoints))
gdwaterpoints.attrs['Units']= '-'


# ===== Create Results group =======================   
print '========== create Results group'
gresults = h5file.create_group( 'Results')
# ==== Create arrays of Results

# === barotropic velocity U
print '========== create barotropic velocity U fields'
ggbarotropicvelocityu= gresults.create_group('barotropic velocity U')
shape=(m_file.barotropic_velocity_u.shape[1],m_file.barotropic_velocity_u.shape[2])
for t in range (m_file.barotropic_velocity_u.shape[0]):
    gdbarotropicvelocityu=ggbarotropicvelocityu.create_dataset ('barotropic velocity U_'+str(str5(t+1)),shape, dtype='f4', maxshape=shape, compression=6,chunks=shape)
    print 'barotropic velocity U_'+str(str5(t+1))
    gdbarotropicvelocityu[:,:]=extrapole(m_file.barotropic_velocity_u[t,:,:] ,-9.9E15)
gdbarotropicvelocityu.attrs['Minimum']=float32(amin(gdbarotropicvelocityu))
gdbarotropicvelocityu.attrs['Maximum']=float32(amin(gdbarotropicvelocityu))
gdbarotropicvelocityu.attrs['Units']='m/s'

# # === barotropic velocity V
print '========== create barotropic velocity V fields'
ggbarotropicvelocityv= gresults.create_group('barotropic velocity V')
shape=(m_file.barotropic_velocity_v.shape[1],m_file.barotropic_velocity_v.shape[2])
for t in range (m_file.barotropic_velocity_v.shape[0]):
    gdbarotropicvelocityv=ggbarotropicvelocityv.create_dataset ('barotropic velocity V_'+str(str5(t+1)),shape, dtype='f4', maxshape=shape, compression=6,chunks=shape)
    print 'barotropic velocity V_'+str(str5(t+1))
    gdbarotropicvelocityv[:,:]=extrapole(m_file.barotropic_velocity_v[t,:,:] ,-9.9E15)
gdbarotropicvelocityv.attrs['Minimum']=float32(amin(gdbarotropicvelocityv))
gdbarotropicvelocityv.attrs['Maximum']=float32(amin(gdbarotropicvelocityv))
gdbarotropicvelocityv.attrs['Units']='m/s'
# # === salinity
print '========== create salinity fields'
ggsalinity= gresults.create_group('salinity')
shape=(1,m_file.salinity.shape[2],m_file.salinity.shape[3])
for t in range (m_file.salinity.shape[0]):
    gdsalinity=ggsalinity.create_dataset ('salinity_'+str(str5(t+1)),shape, dtype='f4', maxshape=shape, compression=6,chunks=shape)
    print 'salinity_'+str(str5(t+1))
    gdsalinity[0,:,:]=extrapole(m_file.salinity[t,0,:,:] ,-9.9E15)
gdsalinity.attrs['Minimum']=float32(amin(gdsalinity))
gdsalinity.attrs['Maximum']=float32(amin(gdsalinity))
gdsalinity.attrs['Units']='C'

# === temperature
print '========== create temperature fields'
ggtemperature= gresults.create_group('temperature')
shape=(1,m_file.temperature.shape[2],m_file.temperature.shape[3])
for t in range (m_file.temperature.shape[0]):
    gdtemperature=ggtemperature.create_dataset ('temperature_'+str(str5(t+1)),shape, dtype='f4', maxshape=shape, compression=6,chunks=shape)
    print 'temperature_'+str(str5(t+1))
    gdtemperature[0,:,:]=extrapole(m_file.temperature[t,0,:,:] ,-9.9E15)
gdtemperature.attrs['Minimum']=float32(amin(gdtemperature))
gdtemperature.attrs['Maximum']=float32(amin(gdtemperature))
gdtemperature.attrs['Units']='C'

# === velocity U
print '========== create velocity U fields'
ggvelocityu= gresults.create_group('velocity U')
shape=(1,m_file.velocity_u.shape[2],m_file.velocity_u.shape[3])
for t in range (m_file.velocity_u.shape[0]):
    gdvelocityu=ggvelocityu.create_dataset ('velocity U_'+str(str5(t+1)),shape, dtype='f4', maxshape=shape, compression=6,chunks=shape)
    print 'velocity U_'+str(str5(t+1))
    gdvelocityu[0,:,:]=extrapole(m_file.velocity_u[t,0,:,:] ,-9.9E15)
gdvelocityu.attrs['Minimum']=float32(amin(gdvelocityu))
gdvelocityu.attrs['Maximum']=float32(amin(gdvelocityu))
gdvelocityu.attrs['Units']='m/s'


# === velocity V
print '========== create velocity V fields'
ggvelocityv= gresults.create_group('velocity V')
shape=(1,m_file.velocity_v.shape[2],m_file.velocity_v.shape[3])
for t in range (m_file.velocity_v.shape[0]):
    gdvelocityv=ggvelocityv.create_dataset ('velocity V_'+str(str5(t+1)),shape, dtype='f4', maxshape=shape, compression=6,chunks=shape)
    print 'velocity V_'+str(str5(t+1))
    gdvelocityv[0,:,:]=extrapole(m_file.velocity_v[t,0,:,:] ,-9.9E15)
gdvelocityv.attrs['Minimum']=float32(amin(gdvelocityv))
gdvelocityv.attrs['Maximum']=float32(amin(gdvelocityv))
gdvelocityv.attrs['Units']='m/s'

# === velocity modulus
print '========== create velocity modulus fields'
ggvelocitymodulus= gresults.create_group('velocity modulus')
shape=(1,m_file.velocity_modulus.shape[2],m_file.velocity_modulus.shape[3])
for t in range (m_file.velocity_modulus.shape[0]):
    gdvelocitymodulus=ggvelocitymodulus.create_dataset ('velocity modulus_'+str(str5(t+1)),shape, dtype='f4', maxshape=shape, compression=6,chunks=shape)
    print 'velocity modulus_'+str(str5(t+1))
    gdvelocitymodulus[0,:,:]=extrapole(m_file.velocity_modulus[t,0,:,:] ,-9.9E15)
gdvelocitymodulus.attrs['Minimum']=float32(amin(gdvelocitymodulus))
gdvelocitymodulus.attrs['Maximum']=float32(amin(gdvelocitymodulus))
gdvelocitymodulus.attrs['Units']='m/s'

# === water level
print '========== create water level fields'
ggwaterlevel= gresults.create_group('water level')
shape=(m_file.water_level.shape[1],m_file.water_level.shape[2])
for t in range (m_file.water_level.shape[0]):
    gdwaterlevel=ggwaterlevel.create_dataset ('water level_'+str(str5(t+1)),shape, dtype='f4', maxshape=shape, compression=6,chunks=shape)
    print 'water level_'+str(str5(t+1))
    gdwaterlevel[:,:]=extrapole(m_file.water_level[t,:,:] ,-9.9E15)
gdwaterlevel.attrs['Minimum']=float32(amin(gdwaterlevel))
gdwaterlevel.attrs['Maximum']=float32(amin(gdwaterlevel))
gdwaterlevel.attrs['Units']='m'

# ===== Create Time group =======================   
print '========== create time group'
gtime = h5file.create_group( 'Time')
gtime.attrs['Minimum']=float32(0)
gtime.attrs['Maximum']=float32(m_file.year[-1])

# ==== Create arrays of Time
print '========== create time fields'
max=1e-15
for t in range(m_file.nbtime):
    print "Time_"+str(str5(t+1))
    gdtime=gtime.create_dataset ("Time_"+str(str5(t+1)),(6,), dtype='f4', maxshape=(6,), compression=6,chunks=(6,)) #, shuffle='true')
    gdtime[0]=float64(m_file.year[t])
    gdtime[1]=float64(m_file.month[t])
    gdtime[2]=float64(m_file.day[t]) 
    gdtime[3]=float64(m_file.hour[t]) 
    gdtime[4]=float64(m_file.minute[t]) 
    gdtime[5]=float64(m_file.second[t]) 
    gdtime.attrs['Minimum']=float32(0)
    gdtime.attrs['Maximum']=float32(m_file.year[-1])
    if max<float32(m_file.year[-1]):
        max=float32(m_file.year[-1])
    gdtime.attrs['Units']='YYYY/MM/DD HH:MM:SS'
gtime.attrs['Minimum']=float32(0)
gtime.attrs['Maximum']=float32(max)

# Close the files
h5file.close()
m_file.close()

print
print 'file ',outputfilename, ' is created !'
print
print '============================================================='
print '    END OF Mercator_2DExtrapole.py                            '
print '============================================================='


# n=raw_input('Type Enter to continue')  
#==================================================================

